

.macro DefineCmp_Entity _x, _y, _vx, _vy, _sx, _sy, _sprite, _etype, _punLast, _estadoSalto, _collisionable, _state, _aim_x, _aim_y, _ai_status, _xdec , _ydec , _vxdec , _vydec
	.db 	_x,  _y
	.db		_vx, _vy
	.db		_sx, _sy 
	.dw 	_sprite
	.db 	_etype 
	.dw 	_punLast
	.db 	_estadoSalto
	.db 	_collisionable
	.db		_state
	.db		_aim_x, _aim_y
	.db		_ai_status 
	.db		_xdec, _ydec
	.db 	_vxdec, _vydec
.endm

e_x			= 0
e_y 		= 1
e_vx 		= 2
e_vy 		= 3
e_sx 		= 4
e_sy  		= 5
e_sprite_l 	= 6
e_sprite_h 	= 7
e_etype  	= 8
e_punLast_l = 9
e_punLast_h = 10
e_estadoSalto = 11
e_collisionable = 12
e_state 	= 13
e_aim_x		= 14
e_aim_y		= 15
e_ai_status	= 16
e_xdec		= 17
e_ydec 		= 18
e_vxdec		= 19
e_vydec 	= 20
tam_e 		= 21

.macro DefineCmp_Entity_default
	DefineCmp_Entity 0, 0, 0, 0, 1, 1, 0x0000, 1, 0xCCCC, 0, 1, 2, 0, 0, e_ai_noAI, 0, 0, 0, 0
.endm 

;;types
e_type_fix			= 1
e_type_player 		= 2
e_type_bala 		= 3

e_type_enemy 		= 4
e_type_enemy_ghost 	= 5
e_type_key 			= 6
e_type_hidden  		= 7
e_type_laser		= 8
e_type_espejo		= 9

;;tipos con los que colisiona

collision_empty 		= 	1
collision_player 		= 	2
collision_bala_player 	= 	3
collision_enemies 		=	4
collision_enemy 		=	5


;;state type

e_dead 	  = 1
e_default = 2
e_alive	  = 3
e_close   = 4
e_open	  = 5

e_turnoff_laser = 6

;;AI type

e_ai_noAI = 1
e_ai_standby = 2
e_ai_moveto = 3
e_ai_laser = 4