;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "man/man_entity.h.s"
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "cmp/array_structure.h.s"

DefineComponentArrayStructure _entity, max_entitites, DefineCmp_Entity_Default



man_entity_getArray::				;; OBTENEMOS EL ARRAY DE LAS ENTIDADES
	ld 		ix, #_entity_array
	ld 		a,(_entity_num)
	ret
man_entity_getArrayInicio_IY::
	ld 		iy, #_entity_array
	ld 		a,(_entity_num)
	ret
man_entity_getArray_IY::			;; OBTENEMOS EL ARRAY DE LAS ENTIDADES

	ld 		iy, #_entity_array
	ld 		a,(_entity_num)

	sub		b
	ld 		c, b				;; DEVOLVEMOS EL NUMERO DE ENTIDADES RESTANTES EN LA VARIABLE C

bucle:
	add     a, #0
	jr 		z,fin
	ld 		de,#tam_e
	add 	iy,de
	dec 	a
	jr 		bucle

fin:
	
	ret


man_entity_init::					;; INICIALIZAMOS EL ARRAY DE ENTIDADES

	xor 	a
	ld 		(_entity_num), a

	ld 		hl,#_entity_array
	ld 		(_entity_pend), hl

	ret

man_entity_nueva::
	ld 		hl,#_entity_num			;; CARGAR EN HL EL NUMERO DE ENTIDADES QUE HAY Y LO INCREMENTAMOS
	inc 	(hl)


	ld 		hl, (_entity_pend)  	;;CARGAR EN HL
	ld 		d, h
	ld 		e, l
	ld 		bc,#tam_e
	add 	hl,bc
	ld 		(_entity_pend),hl

	ret

man_entity_create::
	push hl							;; POSICION DE LA NUEVA ENTIDAD
	call man_entity_nueva


	ld__ixh_d
	ld__ixl_e

	pop hl
	ldir

	ret
