;;This file is part of The castaway of Valhalla: a platform videogame developed for AmstradCPC
;;    Copyright (C)  2020  Arcadevs (@Arca_Devs)
;;
;;    This program is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    This program is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with this program.  If not, see https://www.gnu.org/licenses/.

.include "man/man_game.h.s"
.include "cpctelera.h.s"
.include "cmp/entity.h.s"
.include "man/man_entity.h.s"
.include "sys/physics.h.s"
.include "sys/render.h.s"
.include "sys/input.h.s"
.include "sys/collisions.h.s"
.include "sys/ai_control.h.s"
.include "assets/assets.h.s"
.include "cpct_functions.h.s"





man_game_init::


	ret

;;------------------------------------------------------------------------------------------------------------------------------

man_game_update::

	call man_entity_getArray
	call sys_input_update
	call man_entity_getArray
	call sys_ai_control_update
	call man_entity_getArray
	call sys_physics_update
	call man_entity_getArray
	call sys_collisions_update

	ret

;;------------------------------------------------------------------------------------------------------------------------------

man_game_render::

	call man_entity_getArray
	call sys_eren_update

	ret